#!/usr/bin/perl
# -------------------------------------------------------------
# SMSPreGnokii-send
# -------------------------------------------------------------
# 0.01, 09/04/2000
# -------------------------------------------------------------
#
# Preprocessor for the gnokii command line utility to delete
# a message in the phone memory.
# Andres Seco Hernandez.
# AndresSH@ctv.es
# Guadalajara, Spain, April 2000.
#
# -------------------------------------------------------------

# -------------------------------------------------------------
# Functions
# -------------------------------------------------------------

sub read_conf_file {
# Look for second parameter line into first parameter file.
  my ($file,$word) = @_;
  $answer = "0";
  open (OPTIONS,"<$file");
  while (<OPTIONS>) {
    $record=$_;
    chop ($record);
    @field = split (/\t+/,$record);
    $answer = $field[1] if ( lc($field[0]) eq $word );
  }
  close (OPTIONS);
  return $answer;
}

sub send_log_file {
# Write message to log file depending on loglevel from config file.
# loglevel 1 = Log start and stop messages.
# loglevel 2 = Log start, stop and error messages.
# loglevel 3 = Log start, stop, error and warning messages.
# loglevel 4 = Log start, stop, error, warning and trace messages.
# loglevel 5 = Log start, stop, error, warning, trace and var.trace messages.
  my ($file,$message,$runningll,$messagell) = @_;
  if ( $runningll >= $messagell ) {
    open (LOGF,">>$file");
    print LOGF "SMSPreGnokii-send: ".localtime(time())." ".$message."\n";
    close (LOGF);
  }
}

my ($DestinationNumber,$MessageContent) = @ARGV;

# -------------------------------------------------------------
# Global vars
# -------------------------------------------------------------

$conf_file = "SMSPreGnokii.conf";

# -------------------------------------------------------------
# Main code
# -------------------------------------------------------------

#---- Starting ----
$conf_logfile = read_conf_file($conf_file,"logfile");
$conf_loglevel = read_conf_file($conf_file,"loglevel");
send_log_file($conf_logfile,"SMSPreGnokii v0.01, Preprocessor for the gnokii command line utility.",$conf_loglevel,1);
send_log_file($conf_logfile,"Andres Seco, AndresSH\@ctv.es",$conf_loglevel,1);
send_log_file($conf_logfile,"Starting...",$conf_loglevel,1);
$conf_gnokiipath = read_conf_file($conf_file,"gnokiipath");
$conf_gnokiisendsms = read_conf_file($conf_file,"gnokiisendsms");
send_log_file($conf_logfile,"DestinationNumber=".$DestinationNumber,$conf_loglevel,5);
send_log_file($conf_logfile,"MessageContent=".$MessageContent,$conf_loglevel,5);
send_log_file($conf_logfile,"gnokiipath=".$conf_gnokiipath,$conf_loglevel,5);
send_log_file($conf_logfile,"gnokiisendsms=".$conf_gnokiisendsms,$conf_loglevel,5);

#---- Getting message in the phone ----
$conf_gnokiisendsms =~ s/%PhoneNumber%/$DestinationNumber/g;
send_log_file($conf_logfile,"Substitution of PhoneNumber in send=".$conf_gnokiisendsms,$conf_loglevel,5);
$answer = qx { echo $MessageContent | $conf_gnokiipath $conf_gnokiisendsms 2>&1 };
if ( $answer =~ /Send succeeded/ ) {
  send_log_file($conf_logfile,"OK",$conf_loglevel,2);
  printf "OK\n";
} else {
  send_log_file($conf_logfile,"ERROR",$conf_loglevel,2);
  printf "ERROR\n";
}

#---- Ending ----
send_log_file($conf_logfile,"Ending...",$conf_loglevel,1);

